#ifndef BSS_LINKPROTO_H
#define BSS_LINKPROTO_H

#include "freertos/FreeRTOS.h"

#include "../common/statemachine.h"
#include "../common/taskrunnable.h"
#include "freertos/event_groups.h"

#include "peertable.h"

enum class NLink_State {
    None,
    Discovery,
    Operational,

    count
};

class CLink_Proto_Mgr : public CTask_Runnable {
    private:
        CState_Machine<NLink_State, CLink_Proto_Mgr> mState;
        EventGroupHandle_t mEvent_Handle;

        static CLink_Proto_Mgr* gInstance;

    protected:
        void Transition(NLink_State from, NLink_State to);

    public:
        CLink_Proto_Mgr();

        void Task_Run() override;

        static CLink_Proto_Mgr* Instance() {
            return gInstance;
        }
};

#endif
