#ifndef BSS_NETPROTO_H
#define BSS_NETPROTO_H

#include "freertos/FreeRTOS.h"

#include "../common/statemachine.h"
#include "../common/taskrunnable.h"
#include "freertos/event_groups.h"

#include "../linkproto/peertable.h"

enum class NNet_State {
    None,
    Address_Negotiation,
    Topology_Discovery,
    Operational,

    count
};

class CNet_Proto_Mgr : public CTask_Runnable {
    private:
        CState_Machine<NNet_State, CNet_Proto_Mgr> mState;
        EventGroupHandle_t mEvent_Handle;

        static CNet_Proto_Mgr* gInstance;

    protected:
        void Transition(NNet_State from, NNet_State to);

    public:
        CNet_Proto_Mgr();

        void Task_Run() override;

        static CNet_Proto_Mgr* Instance() {
            return gInstance;
        }
};

#endif
