#pragma once

#include "esp_now.h"
#include "esp_mac.h"

extern const uint8_t Broadcast_L2_Address[ESP_NOW_ETH_ALEN];

class CESP_NOW {

    private:
        bool Initialize_WiFi();
        bool Initialize_ESP_Now();

    public:
        CESP_NOW();

        bool Initialize();

        bool Send(const uint8_t* dst_mac, const uint8_t* data, int len);
        
        bool Add_Peer(const uint8_t* dst_mac);
        bool Remove_Peer(const uint8_t* dst_mac);

        void Send_Callback(const uint8_t *mac_addr, esp_now_send_status_t status);
        void Receive_Callback(const esp_now_recv_info_t *recv_info, const uint8_t *data, int len);
};
