#pragma once

#include <cstdint>

#include "esp_now.h"

static constexpr int Peer_Max_Count = 16;
static constexpr uint16_t Net_Addr_None = static_cast<uint16_t>(-1);

struct TPeer_Table_Entry {
    bool valid = false;
    uint8_t link_addr[ESP_NOW_ETH_ALEN];
    uint16_t net_addr;

    // more info when needed
};

namespace peers {
    void Table_Init();

    const TPeer_Table_Entry* Find_Peer_By_Link_Address(uint8_t link_addr[ESP_NOW_ETH_ALEN]);
    const TPeer_Table_Entry* Find_Peer_By_Net_Address(uint16_t net_addr);

    const TPeer_Table_Entry* Select_Random_Peer();

    bool Add_Peer(const uint8_t link_addr[ESP_NOW_ETH_ALEN]);
    bool Remove_Peer(const uint8_t link_addr[ESP_NOW_ETH_ALEN]);
    bool Set_Peer_Net_Address(const uint8_t link_addr[ESP_NOW_ETH_ALEN], uint16_t net_addr);
    int Get_Peer_Count();
}
