#include <Arduino.h>
#include <ESP8266WiFi.h>

void fpm_wakup_cb_func(void) {
  wifi_fpm_close();
  Serial.println("wake up from light sleep");
  Serial.flush();
}

void lightSleep(int ms)
{
  wifi_set_opmode(NULL_MODE);
  wifi_fpm_set_sleep_type(LIGHT_SLEEP_T);
  wifi_fpm_open();

  wifi_fpm_set_wakeup_cb(fpm_wakup_cb_func);

  wifi_fpm_do_sleep(ms * 1000);

  delay(ms + 1);
}

void setup() {
  Serial.begin(9600);
  Serial.println("Start");

  WiFi.mode(WIFI_STA);
}

void loop() {
  Serial.println("Loop");
  delay(1000);
  Serial.println("Going to sleep");
  Serial.flush();
  lightSleep(5000);
  Serial.println("Loop wakeup");
  delay(1000);
}
