#pragma once

#include <cstdint>

#include "../common/taskrunnable.h"

namespace app_pdu {

    #pragma pack(push, 1)

    struct TSensor_Data {
        uint8_t sensor;
        uint16_t value;
    };

    #pragma pack(pop)
}

class CSensor_Mgr : public CTask_Runnable {
    private:
        static CSensor_Mgr* gInstance;

    public:
        CSensor_Mgr();

        void Task_Run() override;

        void Send_Aggregate_Data(uint8_t addr);

        void Incoming_Data(uint8_t* data, uint16_t data_len);

        static CSensor_Mgr* Instance() {
            return gInstance;
        }
};
