#include "units.h"

#include "esp_random.h"

namespace sensors {

    // NOTE: these are just dummy sensor modules to return dummy data; this is to allow testing with ease

    // retrieves current temperature: range -10 to 40
    uint16_t Get_Temperature() {
        return 16 + ((esp_random() % 6) - 3);
    }

    // retrieves current relative humidity: range 0 to 100
    uint16_t Get_Humidity() {
        return 50 + ((esp_random() % 10) - 5);
    }

    // retrieves current ambient light: range 0 to 100
    uint16_t Get_Ambient_Light() {
        return 75 + ((esp_random() % 6) - 3);
    }

    // retrieves current sound level: range 0 to 100
    uint16_t Get_Sound_Level() {
        return 15 + ((esp_random() % 6) - 3);
    }

    uint16_t Get_Measurement(Measurement_Type type) {
        switch (type) {
            case Measurement_Type::temperature:
                return Get_Temperature();
            case Measurement_Type::humidity:
                return Get_Humidity();
            case Measurement_Type::ambient_light:
                return Get_Ambient_Light();
            case Measurement_Type::sound_level:
                return Get_Sound_Level();
            default:
                return 0;
        }
    }

}
