#pragma once

#include <cstdint>

namespace sensors {

    enum class Measurement_Type : uint8_t {
        temperature = 1,
        humidity = 2,
        ambient_light = 3,
        sound_level = 4,
        // --- HERE YOU CAN ADD MORE MEASUREMENTS ---

        count = sound_level
    };

    // NOTE: these are just dummy sensor modules to return dummy data; this is to allow testing with ease

    // retrieves current temperature: range -10 to 40
    uint16_t Get_Temperature();
    // retrieves current relative humidity: range 0 to 100
    uint16_t Get_Humidity();
    // retrieves current ambient light: range 0 to 100
    uint16_t Get_Ambient_Light();
    // retrieves current sound level: range 0 to 100
    uint16_t Get_Sound_Level();

    uint16_t Get_Measurement(Measurement_Type type);

}
